#include "SnCommWinAfar.h"

#include "SnCommAfarNetIf.h"

SnCommWinAfar::SnCommWinAfar(SnConfigFrame& conf) :
    SnCommWin(new SnCommAfarNetIf(conf.GetRemoteServer(),
                                  conf.GetRemotePort(),
                                  conf.GetMbedIP(), 
                                  conf.GetMbedMask(),
                                  conf.GetMbedGate())) {

}
/*
SnCommWin::ECommWinResult SnCommWinAfar::OpenWindow(const uint32_t timeout,
                                                    const bool sendStatus,
                                                    const SnConfigFrame& conf,
                                                    const SnEventFrame& evt,
                                                    const SnPowerFrame& pow,
                                                    const uint16_t seq,
                                                    const float thmrate,
                                                    const float evtrate,
                                                    const uint32_t powerOnTime,
                                                    const SnTempFrame& temper,
                                                    char* const genBuf) {
*/
SnCommWin::ECommWinResult SnCommWinAfar::OpenWindow(const bool sendStatus,
                                                    const SnConfigFrame& conf,
                                                    const SnPowerFrame& pow, // com win power
                                                    const SnEventFrame& stEvent,
                                                    const uint16_t seq,
                                                    const float thmrate,
                                                    const float evtrate,
                                                    const uint32_t powerOnTime,
                                                    const SnTempFrame& temper, // com win temp
                                                    char* const genBuf,
                                                    const uint32_t timeout_clock) {
#ifdef DEBUG
    printf("SnCommWinAfar::OpenWindow\r\n");
#endif

    const bool canCon = fComm->Connect(timeout_clock);
    
    SnCommWin::ECommWinResult ret = canCon ? SnCommWin::kConnected
                                           : SnCommWin::kCanNotConnect;
    
    if (canCon && sendStatus) {
#ifdef DEBUG
    printf("calling SendStatus\r\n");
#endif
        ret = SendStatus(conf, pow, stEvent, seq, thmrate, evtrate, powerOnTime, temper,
                         genBuf,
                         timeout_clock);

        //ret = SendStatus(conf, evt, pow, seq, thmrate, evtrate, powerOnTime, temper, genBuf, timeout);
#ifdef DEBUG
    printf("Send Status returned\r\n");
#endif
    }
    
    return ret;
}
